(document:surround "/std/frame")
(document:insert "/std/functions")

;;; Functions
(define (read-repository repository-name)
  (woo-catch/message
    (thunk
      (let* ((data (woo-read-first "/pkg-sources" 'name repository-name)))
        (repositories value (woo-get-option data 'name))
	(uri enumref (list "/pkg-sources/avail_mirror" 'name (woo-get-option data 'name))
	     value (woo-get-option data 'uri))))))

(define (write-repository)
  (woo-catch/message
    (thunk
      (woo-write "/pkg-sources" 'commit #t 'name (repositories value) 'uri (uri value))
      (read-repository (repositories value)))))

;;; UI

(gridbox columns "0;100"
	 ;;
	 (label text (_ "Repositories:") colspan 2)
	 ;;
	 (document:id repositories
		      (listbox colspan 2
			       (when selected (read-repository (repositories value)))))
	 ;;
	 (hbox
	       (label text (_ "Source URI:") align "right")
	       (document:id uri (combobox rows)))
	 (button text (_ "Change") align "left" (when clicked (let ((name (repositories value)))
	                                                        (write-repository)
	                                                        (repositories enumref "/pkg-sources/avail_repository")
	                                                        (read-repository name))))
	 (label colspan 2)
	 ;;
	 (spacer)
	 (button text (_ "Anvanced...") align "left"
	         (when clicked (frame:replace "/pkg/sources/mirrors" 'name (repositories value)))))

;;; Logic
(document:root
 (when loaded 
       (repositories enumref "/pkg-sources/avail_repository")
       (read-repository "")))
