(document:surround "/std/frame")
(document:insert "/std/functions")

(define *name* (global 'name))

(define (read-mirror)
  (woo-catch/message
    (thunk
      (let ((data (woo-read-first "/pkg-sources" 'name *name*)))
	(h1 text (bold (string-append (_ "Repository:") (woo-get-option data 'label))))
	(mirrors enumref (list "/pkg-sources/avail_mirror" 'name *name*)
		 value (woo-get-option data 'uri))))))

(define (new-mirror)
  (woo-catch/message
    (thunk
      (woo-write "/pkg-sources"
		 'new #t
		 'name *name*
		 'new_uri (new_uri value))
      (read-mirror))))

(define (delete-mirror)
  (woo-catch/message
    (thunk
      (woo-write "/pkg-sources"
		 'delete #t
		 'name *name*
		 'uri (mirrors value))
      (read-mirror))))

(define (write-mirror)
  (woo-catch/message
    (thunk
      (woo-write "/pkg-sources"
		 'commit #t
		 'name *name*
		 'uri (mirrors value)))))

(define (return)
  (frame:replace "/pkg/sources"))

(gridbox
  columns "100;0"

  (document:id h1 (label colspan 2))
  (label colspan 2)

  (label text  (_ "New source:") colspan 2)
  (document:id new_uri (edit))
  (button text (_ "Add") (when clicked (new-mirror)))

  (label text (_ "Available sources:") colspan 2)
  (document:id mirrors (listbox colspan))
  (button text (_ "Delete") align "top" (when clicked (delete-mirror)))

  (label colspan 2)
  (hbox colspan 2 align "left"
    (button text (_ "OK") align "left" (when clicked (write-mirror) (return)))
    (button text (_ "Cancel") align "left" (when clicked (return)))))

(document:root (when loaded (read-mirror)))

