(document:surround "/std/frame")
(document:insert "/std/functions")

;;; Functions

(define (message-handler . args)
  (woo-catch/ignore
    (thunk
      (let* ((data (woo-read-first "/pkg-upgrade")))
	(msg text (woo-get-option data 'msg))
	(state value (woo-get-option data 'state))
	(update-effect)))))

(define (do-pkg button-name)
  (woo-catch/message
    (thunk (woo-write "/pkg-upgrade" button-name #t))))

;;; UI

;;hidden
(document:id state (edit visibility #f name "state"))

(gridbox
  columns "10;80;10"

  ;;
  (spacer)
  (document:id msg (textbox alterability #f))
  (spacer)

  ;;
  (spacer)
  (hbox align "left"
    (document:id check-button
		 (button text (_ "Check for updates")
		         align "left"
		         name "check"
		         visibility #f
			 (when clicked (do-pkg 'check))))
    (document:id update-button
	       (button text (_ "Update system")
	               align "left"
	               name "upgrade"
	               visibility #f
		       (when clicked (do-pkg 'upgrade))))
    (document:id cancel-button
		 (button text (_ "Cancel")
		         align "left"
		         name "cancel"
		         visibility #f
			 (when clicked (do-pkg 'cancel) (message-handler))))
    (document:id continue-button
		 (button text (_ "Continue")
		         align "left"
		         name "continue"
		         visibility #f
			 (when clicked (do-pkg 'continue)))))

  (spacer))

(frame:on-leave (thunk (remove-mailbox message-handler)))

(effect-show "check" "state" "ready")
(effect-show "upgrade" "state" "ready")

(effect-show "cancel" "state" "check")
(effect-show "cancel" "state" "upgrade")

(effect-show "continue" "state" "waiting")

(document:root
  (when loaded
    (woo-catch/message
      (thunk
	(add-mailbox message-handler)
	(message-handler)
	(init-effect)))))
